using System;
using System.EnterpriseServices;

//create a queue for this application and enable it, but
//dont turn it on yet
[assembly: ApplicationQueuing(Enabled=true, QueueListenerEnabled=false)]

namespace ComPlus2
{	
	//interface that contains the method clients will call
	public interface IQueued
	{
		void ReceiveData(string message);
	}

	//mark the class for queuing, enable the queue, and list the interface
	[InterfaceQueuing(true, Interface="IQueued")]
	public class QueuedClass:ServicedComponent, IQueued
	{
		public QueuedClass(){}
	
		//this method is called by the queue on behalf of the client
		public void ReceiveData(string message)
		{
			System.Windows.Forms.MessageBox.Show(message);
		}
	}
}
